#ifndef SHADER_SHADEREXT_H
#define SHADER_SHADEREXT_H

#include "system/gl.h"

//see if without my manual glext we still need to load the exts...

//imhaving issues with multiple .h files doing this same trick back to back
//good thing windows is the only os that sucks
//i'll just use WIN32 as my test

#ifdef WIN32
//#ifndef GL_ARB_shader_objects
#define LOAD_ARB_shader_objects
//#endif	//GL_ARB_shader_objects

//#ifndef GL_ARB_vertex_program
#define LOAD_ARB_shader_objects
//#endif	//GL_ARB_vertex_program

//#ifndef GL_ARB_vertex_shader
#define LOAD_ARB_vertex_shader
//#endif //GL_ARB_vertex_shader

//#ifndef GL_ARB_vertex_program
#define LOAD_ARB_vertex_program
//#endif //GL_ARB_vertex_program

#endif

#include "base/glext.h"

//then grab junk from glext (esp for typedefs)

extern bool found_GL_ARB_shader_objects;
//if so...
#ifdef LOAD_ARB_shader_objects
extern PFNGLDELETEOBJECTARBPROC			glDeleteObjectARB			;
extern PFNGLGETHANDLEARBPROC			glGetHandleARB				;
extern PFNGLDETACHOBJECTARBPROC			glDetachObjectARB			;
extern PFNGLCREATESHADEROBJECTARBPROC	glCreateShaderObjectARB		;
extern PFNGLSHADERSOURCEARBPROC			glShaderSourceARB			;
extern PFNGLCOMPILESHADERARBPROC		glCompileShaderARB			;
extern PFNGLCREATEPROGRAMOBJECTARBPROC	glCreateProgramObjectARB	;
extern PFNGLATTACHOBJECTARBPROC			glAttachObjectARB			;
extern PFNGLLINKPROGRAMARBPROC			glLinkProgramARB			;
extern PFNGLUSEPROGRAMOBJECTARBPROC		glUseProgramObjectARB		;
extern PFNGLVALIDATEPROGRAMARBPROC		glValidateProgramARB		;
extern PFNGLUNIFORM1FARBPROC			glUniform1fARB				;
extern PFNGLUNIFORM2FARBPROC			glUniform2fARB				;
extern PFNGLUNIFORM3FARBPROC			glUniform3fARB				;
extern PFNGLUNIFORM4FARBPROC			glUniform4fARB				;
extern PFNGLUNIFORM1IARBPROC			glUniform1iARB				;
extern PFNGLUNIFORM2IARBPROC			glUniform2iARB				;
extern PFNGLUNIFORM3IARBPROC			glUniform3iARB				;
extern PFNGLUNIFORM4IARBPROC			glUniform4iARB				;
extern PFNGLUNIFORM1FVARBPROC			glUniform1fvARB				;
extern PFNGLUNIFORM2FVARBPROC			glUniform2fvARB				;
extern PFNGLUNIFORM3FVARBPROC			glUniform3fvARB				;
extern PFNGLUNIFORM4FVARBPROC			glUniform4fvARB				;
extern PFNGLUNIFORM1IVARBPROC			glUniform1ivARB				;
extern PFNGLUNIFORM2IVARBPROC			glUniform2ivARB				;
extern PFNGLUNIFORM3IVARBPROC			glUniform3ivARB				;
extern PFNGLUNIFORM4IVARBPROC			glUniform4ivARB				;
extern PFNGLUNIFORMMATRIX2FVARBPROC		glUniformMatrix2fvARB		;
extern PFNGLUNIFORMMATRIX3FVARBPROC		glUniformMatrix3fvARB		;
extern PFNGLUNIFORMMATRIX4FVARBPROC		glUniformMatrix4fvARB		;
extern PFNGLGETOBJECTPARAMETERFVARBPROC	glGetObjectParameterfvARB	;
extern PFNGLGETOBJECTPARAMETERIVARBPROC	glGetObjectParameterivARB	;
extern PFNGLGETINFOLOGARBPROC			glGetInfoLogARB				;
extern PFNGLGETATTACHEDOBJECTSARBPROC	glGetAttachedObjectsARB		;
extern PFNGLGETUNIFORMLOCATIONARBPROC	glGetUniformLocationARB		;
extern PFNGLGETACTIVEUNIFORMARBPROC		glGetActiveUniformARB		;
extern PFNGLGETUNIFORMFVARBPROC			glGetUniformfvARB			;
extern PFNGLGETUNIFORMIVARBPROC			glGetUniformivARB			;
extern PFNGLGETSHADERSOURCEARBPROC		glGetShaderSourceARB		;
#endif //LOAD_ARB_shader_objects

extern bool found_GL_ARB_vertex_shader;

#ifdef LOAD_ARB_vertex_shader
extern PFNGLBINDATTRIBLOCATIONARBPROC	glBindAttribLocationARB;
extern PFNGLGETACTIVEATTRIBARBPROC		glGetActiveAttribARB;
extern PFNGLGETATTRIBLOCATIONARBPROC	glGetAttribLocationARB;
#endif

extern bool found_GL_ARB_vertex_program;
//if so...
#ifdef LOAD_ARB_vertex_program
extern PFNGLVERTEXATTRIB1DARBPROC	glVertexAttrib1dARB;
extern PFNGLVERTEXATTRIB1DVARBPROC	glVertexAttrib1dvARB;
extern PFNGLVERTEXATTRIB1FARBPROC	glVertexAttrib1fARB;
extern PFNGLVERTEXATTRIB1FVARBPROC	glVertexAttrib1fvARB;
extern PFNGLVERTEXATTRIB1SARBPROC	glVertexAttrib1sARB;
extern PFNGLVERTEXATTRIB1SVARBPROC	glVertexAttrib1svARB;
extern PFNGLVERTEXATTRIB2DARBPROC	glVertexAttrib2dARB;
extern PFNGLVERTEXATTRIB2DVARBPROC	glVertexAttrib2dvARB;
extern PFNGLVERTEXATTRIB2FARBPROC	glVertexAttrib2fARB;
extern PFNGLVERTEXATTRIB2FVARBPROC	glVertexAttrib2fvARB;
extern PFNGLVERTEXATTRIB2SARBPROC	glVertexAttrib2sARB;
extern PFNGLVERTEXATTRIB2SVARBPROC	glVertexAttrib2svARB;
extern PFNGLVERTEXATTRIB3DARBPROC	glVertexAttrib3dARB;
extern PFNGLVERTEXATTRIB3DVARBPROC	glVertexAttrib3dvARB;
extern PFNGLVERTEXATTRIB3FARBPROC	glVertexAttrib3fARB;
extern PFNGLVERTEXATTRIB3FVARBPROC	glVertexAttrib3fvARB;
extern PFNGLVERTEXATTRIB3SARBPROC	glVertexAttrib3sARB;
extern PFNGLVERTEXATTRIB3SVARBPROC	glVertexAttrib3svARB;
extern PFNGLVERTEXATTRIB4NBVARBPROC	glVertexAttrib4NbvARB;
extern PFNGLVERTEXATTRIB4NIVARBPROC	glVertexAttrib4NivARB;
extern PFNGLVERTEXATTRIB4NSVARBPROC	glVertexAttrib4NsvARB;
extern PFNGLVERTEXATTRIB4NUBARBPROC	glVertexAttrib4NubARB;
extern PFNGLVERTEXATTRIB4NUBVARBPROC	glVertexAttrib4NubvARB;
extern PFNGLVERTEXATTRIB4NUIVARBPROC	glVertexAttrib4NuivARB;
extern PFNGLVERTEXATTRIB4NUSVARBPROC	glVertexAttrib4NusvARB;
extern PFNGLVERTEXATTRIB4BVARBPROC	glVertexAttrib4bvARB;
extern PFNGLVERTEXATTRIB4DARBPROC	glVertexAttrib4dARB;
extern PFNGLVERTEXATTRIB4DVARBPROC	glVertexAttrib4dvARB;
extern PFNGLVERTEXATTRIB4FARBPROC	glVertexAttrib4fARB;
extern PFNGLVERTEXATTRIB4FVARBPROC	glVertexAttrib4fvARB;
extern PFNGLVERTEXATTRIB4IVARBPROC	glVertexAttrib4ivARB;
extern PFNGLVERTEXATTRIB4SARBPROC	glVertexAttrib4sARB;
extern PFNGLVERTEXATTRIB4SVARBPROC	glVertexAttrib4svARB;
extern PFNGLVERTEXATTRIB4UBVARBPROC	glVertexAttrib4ubvARB;
extern PFNGLVERTEXATTRIB4UIVARBPROC	glVertexAttrib4uivARB;
extern PFNGLVERTEXATTRIB4USVARBPROC	glVertexAttrib4usvARB;
extern PFNGLVERTEXATTRIBPOINTERARBPROC	glVertexAttribPointerARB;
extern PFNGLENABLEVERTEXATTRIBARRAYARBPROC	glEnableVertexAttribArrayARB;
extern PFNGLDISABLEVERTEXATTRIBARRAYARBPROC	glDisableVertexAttribArrayARB;
extern PFNGLPROGRAMSTRINGARBPROC	glProgramStringARB;
extern PFNGLBINDPROGRAMARBPROC	glBindProgramARB;
extern PFNGLDELETEPROGRAMSARBPROC	glDeleteProgramsARB;
extern PFNGLGENPROGRAMSARBPROC	glGenProgramsARB;
extern PFNGLPROGRAMENVPARAMETER4DARBPROC	glProgramEnvParameter4dARB;
extern PFNGLPROGRAMENVPARAMETER4DVARBPROC	glProgramEnvParameter4dvARB;
extern PFNGLPROGRAMENVPARAMETER4FARBPROC	glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARBPROC	glProgramEnvParameter4fvARB;
extern PFNGLPROGRAMLOCALPARAMETER4DARBPROC	glProgramLocalParameter4dARB;
extern PFNGLPROGRAMLOCALPARAMETER4DVARBPROC	glProgramLocalParameter4dvARB;
extern PFNGLPROGRAMLOCALPARAMETER4FARBPROC	glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC	glProgramLocalParameter4fvARB;
extern PFNGLGETPROGRAMENVPARAMETERDVARBPROC	glGetProgramEnvParameterdvARB;
extern PFNGLGETPROGRAMENVPARAMETERFVARBPROC	glGetProgramEnvParameterfvARB;
extern PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC	glGetProgramLocalParameterdvARB;
extern PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC	glGetProgramLocalParameterfvARB;
extern PFNGLGETPROGRAMIVARBPROC	glGetProgramivARB;
extern PFNGLGETPROGRAMSTRINGARBPROC	glGetProgramStringARB;
extern PFNGLGETVERTEXATTRIBDVARBPROC	glGetVertexAttribdvARB;
extern PFNGLGETVERTEXATTRIBFVARBPROC	glGetVertexAttribfvARB;
extern PFNGLGETVERTEXATTRIBIVARBPROC	glGetVertexAttribivARB;
extern PFNGLGETVERTEXATTRIBPOINTERVARBPROC	glGetVertexAttribPointervARB;
extern PFNGLISPROGRAMARBPROC	glIsProgramARB;
#endif //LOAD_ARB_vertex_program

class ShaderSystem {
public:
	bool init();
};
extern ShaderSystem shaderSystem;

#endif //SHADER_SHADEREXT_H